Skip to main content

The 2 Missing Duplicate Numbers - Medium


This is a slightly trickier version of The Missing Duplicate Number. Instead of one single missing number, we have 2.

Problem : Given an array of Integers. Each number is repeated even number of times. Except 2 numbers which occur odd number of times. Find the two numbers Ex. [1,2,3,1,2,3,4,5] The Output should be 4,5.


The naive solution is similar to the previous solution. Use a hash table to keep track of the frequencies and find the elements that occur an odd number of times. The algorithm has a Time and Space Complexity of O(n).

Say those two required numbers are a and b
If you remember the previous post, we used the XOR over all the elements to find the required element. If we do the same here, we get a value xor which is actually a ^ b.

So how can we use this? We know that a and b are different, so their xor is not zero. Infact their XOR value has its bit set for all its dissimilar bits in both a and b. (eg. 1101 ^ 0110 = 0011).

It's important to notice here that each bit set in xor corresponds to either a or b, but not both. So we isolate a single bit from xor  , say mask, and run the original XOR algorithm only for those number whose bit  is set the same as mask. This list of elements will either have a or b. depending on whether the bit was set due to a or b. So the xor algorithm will return one of the numbers,say xor_1. To obtain the other we simply xor ^ xor_1.

Example:
[1,2,3,4,5,1,2,3]

xor = 1 ^ 2 ^ 3 ^ 4 ^ 5 ^ 1 ^ 2 ^3 = 1 ( = 4 ^ 5)

Notice, 4 = 0100  and 5 = 0101 , xor = 0001.

In this case, since there's just one bit set, xor itself is the mask.
Now, we calculate xor_1. Ie XOR all number whose (v & mask) != 0

xor_1 = 1 ^ 3 ^ 5 ^ 1 ^ 3 = 5
xor_2 = xor ^ xor_1 = 1 ^ 5 = 4

We obtain (4,5) which occurred odd number of times.


import random
r = {random.randint(10,100) for i in xrange(10)}
lst = random.sample(r,len(r))
l = lst[:2] + lst[2:] * 2
random.shuffle(l)
def missing_2_numbers(lst):
xor = reduce(lambda a,b : a ^ b, lst)
mask = (xor & -xor) #get the right most set bit.
xor_1 = 0
for v in lst:
if v & mask:
xor_1 = xor_1 ^ v
return (xor_1,xor ^ xor_1)
print l
print missing_2_numbers(l)

Comments

Popular posts from this blog

Find Increasing Triplet Subsequence - Medium

Problem - Given an integer array A[1..n], find an instance of i,j,k where 0 < i < j < k <= n and A[i] < A[j] < A[k]. Let's start with the obvious solution, bruteforce every three element combination until we find a solution. Let's try to reduce this by searching left and right for each element, we search left for an element smaller than the current one, towards the right an element greater than the current one. When we find an element that has both such elements, we found the solution. The complexity of this solution is O(n^2). To reduce this even further, One can simply apply the longest increasing subsequence algorithm and break when we get an LIS of length 3. But the best algorithm that can find an LIS is O(nlogn) with O( n ) space . An O(nlogn) algorithm seems like an overkill! Can this be done in linear time? The Algorithm: We iterate over the array and keep track of two things. The minimum value iterated over (min) The minimum increa...

Dijkstra's algorithm - Part 1 - Tutorial

This will be a 3 Part series of posts where I will be implementing the Dijkstra's Shortest Path algorithm in Python. The three parts will be 1) Representing the Graph 2) Priority Queue 3) The Algorithm To represent a graph we'll be using an  Adjacency List . Another alternative is using an Adjacency Matrix, but for a sparse graph an Adjacency List is more efficient. Adjacency List An Adjacency List is usually represented as a HashTable (or an Array) where an entry at `u` contains a Linked List. The Linked List contains `v` and optionally another parameter `w`. Here `u` and `v` are node(or vertex) labels and `w` is the weight of the edge. By Traversing the linked list we obtain the immediate neighbours of `u`. Visually, it looks like this. For implementing this in Python, we'll be using the dict()  for the main HashTable. For the Linked List we can use a list of 2 sized tuples (v,w).  Sidenote: Instead of a list of tuples, you can use a dict(), ...

Find the Quadruplets - Hard

Problem - Given 4 arrays A,B,C,D. Find out if there exists an instance where A[i] + B[j] + C[k] + D[l] = 0 Like the Find the Triple problem, we're going to develop 4 algorithms to solve this. Starting with the naive O(n^4) solution. Then we proceed to eliminate the inner-most loop with a Binary Search, reducing the complexity to O(n^3 logn) Now, we replace the last 2 loops with the left-right traversal we did in the previous 3 posts. Now the complexity is O(n^3). Finally, we reduce the complexity to O(n^2 logn) at the cost of O(n^2) Space Complexity. We store every combination of A[i] + B[j] and store it in AB[]. Similarly we make CD[] out of C[i] + D[j]. So, AB = A x B CD = C x D We then sort AB and CD (which costs O(n^2 log(n^2)) ~ O(n^2 logn) ) and then run a left-right linear Algorithm on AB and CD. (Note : Their size is of the order O(n^2)) So the overall complexity is due to sorting the large array of size n^2. which is O(n^2 logn).